package stastro

import (
	"math"

	"gitlab.com/solsw/TurboPower/SysTools/internal/common"
)

func _GetLongitudeMercury(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	L0 := 4.40250710140 * math.Cos(0.00000000000+0.00000000000*Tau)
	L0 += 0.40989414976 * math.Cos(1.48302034190+26087.90314200000*Tau)
	L0 += 0.05046294199 * math.Cos(4.47785489540+52175.80628300000*Tau)
	L0 += 0.00855346843 * math.Cos(1.16520322350+78263.70942500000*Tau)
	L0 += 0.00165590362 * math.Cos(4.11969163180+104351.61257000000*Tau)
	L0 += 0.00034561897 * math.Cos(0.77930765817+130439.51571000000*Tau)
	L0 += 0.00007583476 * math.Cos(3.71348400510+156527.41885000000*Tau)
	L0 += 0.00003559740 * math.Cos(1.51202669420+1109.37855210000*Tau)
	L0 += 0.00001803463 * math.Cos(4.10333178410+5661.33204920000*Tau)
	L0 += 0.00001726012 * math.Cos(0.35832239908+182615.32199000000*Tau)
	L0 += 0.00001589923 * math.Cos(2.99510417810+25028.52121100000*Tau)
	L0 += 0.00001364682 * math.Cos(4.59918318740+27197.28169400000*Tau)
	L0 += 0.00001017332 * math.Cos(0.88031439040+31749.23519100000*Tau)
	L0 += 0.00000714182 * math.Cos(1.54144865260+24978.52458900000*Tau)
	L0 += 0.00000643759 * math.Cos(5.30266110790+21535.94964400000*Tau)
	L0 += 0.00000451137 * math.Cos(6.04989275290+51116.42435300000*Tau)
	L0 += 0.00000404200 * math.Cos(3.28228847030+208703.22513000000*Tau)
	L0 += 0.00000352441 * math.Cos(5.24156297100+20426.57109200000*Tau)
	L0 += 0.00000345212 * math.Cos(2.79211901540+15874.61759500000*Tau)
	L0 += 0.00000343313 * math.Cos(5.76531885340+955.59974161000*Tau)
	L0 += 0.00000339214 * math.Cos(5.86327765000+25558.21217600000*Tau)
	L0 += 0.00000325335 * math.Cos(1.33674334780+53285.18483500000*Tau)
	L0 += 0.00000272947 * math.Cos(2.49451163980+529.69096509000*Tau)
	L0 += 0.00000264336 * math.Cos(3.91705094010+57837.13833200000*Tau)
	L0 += 0.00000259587 * math.Cos(0.98732428184+4551.95349710000*Tau)
	L0 += 0.00000238793 * math.Cos(0.11343953378+1059.38193020000*Tau)
	L0 += 0.00000234830 * math.Cos(0.26672118900+11322.66409800000*Tau)
	L0 += 0.00000216645 * math.Cos(0.65987207348+13521.75144200000*Tau)
	L0 += 0.00000208995 * math.Cos(2.09178234010+47623.85278600000*Tau)
	L0 += 0.00000183359 * math.Cos(2.62878670780+27043.50288300000*Tau)
	L0 += 0.00000181629 * math.Cos(2.43413502470+25661.30495100000*Tau)
	L0 += 0.00000175965 * math.Cos(4.53636829860+51066.42773100000*Tau)
	L0 += 0.00000172643 * math.Cos(2.45200164170+24498.83024600000*Tau)
	L0 += 0.00000142316 * math.Cos(3.36003948840+37410.56724000000*Tau)
	L0 += 0.00000137942 * math.Cos(0.29098447849+10213.28554600000*Tau)
	L0 += 0.00000125219 * math.Cos(3.72079804430+39609.65458300000*Tau)
	L0 += 0.00000118233 * math.Cos(2.78149786370+77204.32749400000*Tau)
	L0 += 0.00000106422 * math.Cos(4.20572116250+19804.82729200000*Tau)

	L1 := 26088.1470620 * math.Cos(0.00000000000+0.00000000000*Tau)
	L1 += 0.01126007832 * math.Cos(6.21703971000+26087.90314200000*Tau)
	L1 += 0.00303471395 * math.Cos(3.05565472360+52175.80628300000*Tau)
	L1 += 0.00080538452 * math.Cos(6.10454743370+78263.70942500000*Tau)
	L1 += 0.00021245035 * math.Cos(2.83531934450+104351.61257000000*Tau)
	L1 += 0.00005592094 * math.Cos(5.82675673330+130439.51571000000*Tau)
	L1 += 0.00001472233 * math.Cos(2.51845458400+156527.41885000000*Tau)
	L1 += 0.00000388318 * math.Cos(5.48039225890+182615.32199000000*Tau)
	L1 += 0.00000352244 * math.Cos(3.05238094400+1109.37855210000*Tau)
	L1 += 0.00000102743 * math.Cos(2.14879173780+208703.22513000000*Tau)
	L1 += 0.00000093540 * math.Cos(6.11791163930+27197.28169400000*Tau)
	L1 += 0.00000090579 * math.Cos(0.00045481669+24978.52458900000*Tau)
	L1 += 0.00000051941 * math.Cos(5.62107554050+5661.33204920000*Tau)
	L1 += 0.00000044370 * math.Cos(4.57348500460+25028.52121100000*Tau)
	L1 += 0.00000028070 * math.Cos(3.04195430990+51066.42773100000*Tau)
	L1 += 0.00000027295 * math.Cos(5.09210138840+234791.12827000000*Tau)

	L2 := 0.00053049845 * math.Cos(0.00000000000+0.00000000000*Tau)
	L2 += 0.00016903658 * math.Cos(4.69072300650+26087.90314200000*Tau)
	L2 += 0.00007396711 * math.Cos(1.34735624670+52175.80628300000*Tau)
	L2 += 0.00003018297 * math.Cos(4.45643539700+78263.70942500000*Tau)
	L2 += 0.00001107419 * math.Cos(1.26226537550+104351.61257000000*Tau)
	L2 += 0.00000378173 * math.Cos(4.31998055900+130439.51571000000*Tau)
	L2 += 0.00000122998 * math.Cos(1.06868541050+156527.41885000000*Tau)
	L2 += 0.00000038663 * math.Cos(4.08011610180+182615.32199000000*Tau)
	L2 += 0.00000014898 * math.Cos(4.63343085810+1109.37855210000*Tau)
	L2 += 0.00000011861 * math.Cos(0.79187646439+208703.22513000000*Tau)

	L3 := 0.00000188077 * math.Cos(0.03466830117+52175.80628300000*Tau)
	L3 += 0.00000142152 * math.Cos(3.12505452600+26087.90314200000*Tau)
	L3 += 0.00000096877 * math.Cos(3.00378171920+78263.70942500000*Tau)
	L3 += 0.00000043669 * math.Cos(6.01867965830+104351.61257000000*Tau)
	L3 += 0.00000035395 * math.Cos(0.00000000000+0.00000000000*Tau)
	L3 += 0.00000018045 * math.Cos(2.77538373990+130439.51571000000*Tau)
	L3 += 0.00000006971 * math.Cos(5.81808665740+156527.41885000000*Tau)
	L3 += 0.00000002556 * math.Cos(2.57014364450+182615.32199000000*Tau)

	L4 := 0.00000114078 * math.Cos(3.14159265360+0.00000000000*Tau)
	L4 += 0.00000003247 * math.Cos(2.02848007620+26087.90314200000*Tau)
	L4 += 0.00000001914 * math.Cos(1.41731803760+78263.70942500000*Tau)
	L4 += 0.00000001727 * math.Cos(4.50137643800+52175.80628300000*Tau)
	L4 += 0.00000001237 * math.Cos(4.49970181060+104351.61257000000*Tau)
	L4 += 0.00000000645 * math.Cos(1.26591776990+130439.51571000000*Tau)

	L5 := 0.00000000877 * math.Cos(3.14159265360+0.00000000000*Tau)
	return L0 + L1*Tau + L2*Tau2 + L3*Tau3 + L4*Tau4 + L5*Tau5
}

func _GetLatitudeMercury(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	B0 := 0.11737528962 * math.Cos(1.98357498770+26087.90314200000*Tau)
	B0 += 0.02388076996 * math.Cos(5.03738959690+52175.80628300000*Tau)
	B0 += 0.01222839532 * math.Cos(3.14159265360+0.00000000000*Tau)
	B0 += 0.00543251810 * math.Cos(1.79644363960+78263.70942500000*Tau)
	B0 += 0.00129778770 * math.Cos(4.83232503960+104351.61257000000*Tau)
	B0 += 0.00031866927 * math.Cos(1.58088495670+130439.51571000000*Tau)
	B0 += 0.00007963301 * math.Cos(4.60972126350+156527.41885000000*Tau)
	B0 += 0.00002014189 * math.Cos(1.35324164690+182615.32199000000*Tau)
	B0 += 0.00000513953 * math.Cos(4.37835409310+208703.22513000000*Tau)
	B0 += 0.00000208584 * math.Cos(2.02020294150+24978.52458900000*Tau)
	B0 += 0.00000207674 * math.Cos(4.91772564070+27197.28169400000*Tau)
	B0 += 0.00000132013 * math.Cos(1.11908492280+234791.12827000000*Tau)
	B0 += 0.00000121395 * math.Cos(1.81271752060+53285.18483500000*Tau)
	B0 += 0.00000100454 * math.Cos(5.65684734210+20426.57109200000*Tau)

	B1 := 0.00429151362 * math.Cos(3.50169780390+26087.90314200000*Tau)
	B1 += 0.00146233668 * math.Cos(3.14159265360+0.00000000000*Tau)
	B1 += 0.00022675295 * math.Cos(0.01515366880+52175.80628300000*Tau)
	B1 += 0.00010894981 * math.Cos(0.48540174006+78263.70942500000*Tau)
	B1 += 0.00006353462 * math.Cos(3.42943919980+104351.61257000000*Tau)
	B1 += 0.00002495743 * math.Cos(0.16051210665+130439.51571000000*Tau)
	B1 += 0.00000859585 * math.Cos(3.18452433650+156527.41885000000*Tau)
	B1 += 0.00000277503 * math.Cos(6.21020774180+182615.32199000000*Tau)
	B1 += 0.00000086233 * math.Cos(2.95244391820+208703.22513000000*Tau)
	B1 += 0.00000027696 * math.Cos(0.29068938889+27197.28169400000*Tau)
	B1 += 0.00000026133 * math.Cos(5.97708962690+234791.12827000000*Tau)

	B2 := 0.00011830934 * math.Cos(4.79065585780+26087.90314200000*Tau)
	B2 += 0.00001913516 * math.Cos(0.00000000000+0.00000000000*Tau)
	B2 += 0.00001044801 * math.Cos(1.21216540540+52175.80628300000*Tau)
	B2 += 0.00000266213 * math.Cos(4.43418336530+78263.70942500000*Tau)
	B2 += 0.00000170280 * math.Cos(1.62255638710+104351.61257000000*Tau)
	B2 += 0.00000096300 * math.Cos(4.80023692020+130439.51571000000*Tau)
	B2 += 0.00000044692 * math.Cos(1.60758267770+156527.41885000000*Tau)
	B2 += 0.00000018316 * math.Cos(4.66904655380+182615.32199000000*Tau)
	B2 += 0.00000006927 * math.Cos(1.43404888930+208703.22513000000*Tau)

	B3 := 0.00000235423 * math.Cos(0.35387524604+26087.90314200000*Tau)
	B3 += 0.00000160537 * math.Cos(0.00000000000+0.00000000000*Tau)
	B3 += 0.00000018904 * math.Cos(4.36275460260+52175.80628300000*Tau)
	B3 += 0.00000006376 * math.Cos(2.50715381440+78263.70942500000*Tau)
	B3 += 0.00000004580 * math.Cos(6.14257817570+104351.61257000000*Tau)
	B3 += 0.00000003061 * math.Cos(3.12497552680+130439.51571000000*Tau)
	B3 += 0.00000001732 * math.Cos(6.26642412060+156527.41885000000*Tau)

	B4 := 0.00000004276 * math.Cos(1.74579932120+26087.90314200000*Tau)
	B4 += 0.00000001023 * math.Cos(3.14159265360+0.00000000000*Tau)

	B5 := 0.00000000000 * math.Cos(0.00000000000+0.00000000000*Tau)
	return B0 + B1*Tau + B2*Tau2 + B3*Tau3 + B4*Tau4 + B5*Tau5
}

func _GetRadiusVectorMercury(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	R0 := 0.39528271652 * math.Cos(0.00000000000+0.00000000000*Tau)
	R0 += 0.07834131817 * math.Cos(6.19233722600+26087.90314200000*Tau)
	R0 += 0.00795525557 * math.Cos(2.95989690100+52175.80628300000*Tau)
	R0 += 0.00121281763 * math.Cos(6.01064153810+78263.70942500000*Tau)
	R0 += 0.00021921969 * math.Cos(2.77820093970+104351.61257000000*Tau)
	R0 += 0.00004354065 * math.Cos(5.82894543260+130439.51571000000*Tau)
	R0 += 0.00000918228 * math.Cos(2.59650562600+156527.41885000000*Tau)
	R0 += 0.00000289955 * math.Cos(1.42441936950+25028.52121100000*Tau)
	R0 += 0.00000260033 * math.Cos(3.02817753480+27197.28169400000*Tau)
	R0 += 0.00000201855 * math.Cos(5.64725040350+182615.32199000000*Tau)
	R0 += 0.00000201499 * math.Cos(5.59227724200+31749.23519100000*Tau)
	R0 += 0.00000141980 * math.Cos(6.25264202640+24978.52458900000*Tau)
	R0 += 0.00000100144 * math.Cos(3.73435608690+21535.94964400000*Tau)

	R1 := 0.00217347739 * math.Cos(4.65617158660+26087.90314200000*Tau)
	R1 += 0.00044141826 * math.Cos(1.42385543980+52175.80628300000*Tau)
	R1 += 0.00010094479 * math.Cos(4.47466326320+78263.70942500000*Tau)
	R1 += 0.00002432804 * math.Cos(1.24226083430+104351.61257000000*Tau)
	R1 += 0.00001624367 * math.Cos(0.00000000000+0.00000000000*Tau)
	R1 += 0.00000603996 * math.Cos(4.29303116560+130439.51571000000*Tau)
	R1 += 0.00000152851 * math.Cos(1.06060779810+156527.41885000000*Tau)
	R1 += 0.00000039202 * math.Cos(4.11136751420+182615.32199000000*Tau)

	R2 := 0.00003117867 * math.Cos(3.08231840300+26087.90314200000*Tau)
	R2 += 0.00001245396 * math.Cos(6.15183317420+52175.80628300000*Tau)
	R2 += 0.00000424822 * math.Cos(2.92583352960+78263.70942500000*Tau)
	R2 += 0.00000136130 * math.Cos(5.97983925840+104351.61257000000*Tau)
	R2 += 0.00000042175 * math.Cos(2.74936980630+130439.51571000000*Tau)
	R2 += 0.00000021759 * math.Cos(3.14159265360+0.00000000000*Tau)
	R2 += 0.00000012793 * math.Cos(5.80143162210+156527.41885000000*Tau)

	R3 := 0.00000032676 * math.Cos(1.67971635360+26087.90314200000*Tau)
	R3 += 0.00000024166 * math.Cos(4.63403169000+52175.80628300000*Tau)
	R3 += 0.00000012133 * math.Cos(1.38983781540+78263.70942500000*Tau)
	R3 += 0.00000005140 * math.Cos(4.43915386930+104351.61257000000*Tau)
	R3 += 0.00000001981 * math.Cos(1.20733880270+130439.51571000000*Tau)

	R4 := 0.00000000000

	R5 := 0.00000000000
	return R0 + R1*Tau + R2*Tau2 + R3*Tau3 + R4*Tau4 + R5*Tau5
}

// ComputeMercury
func ComputeMercury(JD float64) TStEclipticalCord {
	var (
		Tau, Tau2, Tau3, Tau4, Tau5 float64
		Result                      TStEclipticalCord
	)
	Tau = (JD - 2451545.0) / 365250.0
	Tau2 = common.Sqr(Tau)
	Tau3 = Tau * Tau2
	Tau4 = common.Sqr(Tau2)
	Tau5 = Tau2 * Tau3

	Result.L0 = _GetLongitudeMercury(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.B0 = _GetLatitudeMercury(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.R0 = _GetRadiusVectorMercury(Tau, Tau2, Tau3, Tau4, Tau5)
	return Result
} // ComputeMercury
